package de.intevation.gnv.transition;

import de.intevation.gnv.artifacts.GNVArtifactBase;

import org.apache.log4j.Logger;

import org.w3c.dom.Node;

/**
 * @author <a href="mailto:tim.englich@intevation.de">Tim Englich</a>
 *
 */
public class TransitionFactory {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(GNVArtifactBase.class);

    private static TransitionFactory instance = null;

    /**
     * Constructor
     */
    public TransitionFactory() {
        super();
    }

    public static TransitionFactory getInstance() {
        if (instance == null) {
            instance = new TransitionFactory();
        }
        return instance;
    }

    public Transition createTransition(Node configuration) {
        log.debug("TransitionFactory.createTransition");
        Transition state = null;
        try {
            String classname = ((org.w3c.dom.Element)configuration).getAttribute("transition");
            state = (Transition) (Class.forName(classname).newInstance());
            state.setup(configuration);
        } catch (InstantiationException e) {
            log.error(e, e);
        } catch (IllegalAccessException e) {
            log.error(e, e);
        } catch (ClassNotFoundException e) {
            log.error(e, e);
        }
        return state;
    }

}
